'----------------------------------------------------------------------------------------------
'-      DISPLAYTEST & TOUCHSCREEN TEST with eDIP240-7 connected to ATMega8                    -
'-                                                                                            -
'-                                                                                            -
'-      Requirements:                                                                         -
'-                     - "displaymkrs_gallerydrive.eep" has to be uploaded on edip240-7       -
'-                     - i2c connection between atmega8 (sda=portd.2 / scl=portd.3) & edip    -
'-                     - edip pin6 on atmega8 pin b0 / edip pin7 on atmega8 pin b1            -
'-                     - eDIP240-7 with at least Firmware Version 1.6                         -
'-                     - close solderbridge J2 on eDIP to switch off smallprotocol            -
'-                     - rs232 terminal connected to atmega8                                  -
'----------------------------------------------------------------------------------------------

      $regfile = "m8def.dat"                                'Atmega8-declarations
      $crystal = 3686400
      $baud = 9600

      Ddrb = &B00000000                                     'switch portb.0 and portb.1 as inputs
      Portb = &B11111111                                    'switch on pullups for portb.0 and portb.1

'----- begin variables used in dspl and readvol subroutines -----

      Dim Send$ As String * 64 At &H60                      'string, which will be sent to eDIP 240-7 | fill this string with up to 62 characters before calling the "dspl"-subroutine
      Dim Send(64) As Byte At &H60 Overlay                  'pointer of send$
      Dim Sendlength As Byte                                'is used in dspl subroutine
      Dim Receivevol(5) As Byte                             'is used in "readvol"-subroutine
      Dim Volume As Byte                                    'will be reutrned from "readvol"-subroutine | values go from 0 to 100

'----- end variables used in dspl and readvol subroutines   -----

      Dim I As Integer                                      'general purpose counter - not used in subroutine
      Dim Scrcont As Byte                                   'stores number of the actual screencontent
      Dim Prvscrcont As Byte                                'stores number of the previous screencontent

      Config Sda = Portd.2
      Config Scl = Portd.3
      Config I2cdelay = 10


'---------------------------------------------------------------------------------
'------------------------------ START PROGLOOP -----------------------------------
'---------------------------------------------------------------------------------

Do
   Scrcont = 0
   Prvscrcont = 0

   Waitms 3000

   Send$ = "{027}MN{001}"                                   'starts macro#1 @ edip 240-7 (this macro will set the screen bgnd and define the bargraph for controlling the volume)
   Gosub Dspl
   Waitms 50

      Scrcont = 1

      Prgloop:
         On Scrcont Gosub Logoscreen , Startscreen , Yesnoscreen , Abscreen , Leftrightscreen
         Gosub Readvol
         Print "Content:.." ; Scrcont ; "        Volume:." ; Volume
         Waitms 50
      Goto Prgloop
Loop

'---------------------------------------------------------------------------------
'------------------------------- END PROGLOOP ------------------------------------
'---------------------------------------------------------------------------------

Logoscreen:
   Prvscrcont = Scrcont
      Send$ = "#MN0"                                        'starts macro#0 (logo animation)
      Gosub Dspl                                            ' (i used another syntax, because the atmega has got problems with chr(0))
   Waitms 3000
   Send$ = "{027}MN{001}"                                   'starts macro#2 (screen setup)
   Gosub Dspl
   Scrcont = 1
Return



Startscreen:
 If Scrcont <> Prvscrcont Then
   Send$ = "{027}MN{004}"                                   'starts macro#4 (start button)
   Gosub Dspl
   Send$ = "#ZF0"                                           'select font#0
   Gosub Dspl
   Send$ = "{027}ZZ{001}{002}"                              'zoom font
   Gosub Dspl
   Send$ = "{027}ZL{010}{030}Do you want..."
   Gosub Dspl
   Send$ = "{027}ZZ{002}{003}"                              'zoom font
   Gosub Dspl
   Send$ = "{027}ZL{005}{055}...a @ride@"
   Gosub Dspl
   Send$ = "{027}MN{008}"                                   'display rotating "?"
   Gosub Dspl
 End If
 Prvscrcont = Scrcont
 If Pinb.0 = 1 Then
   Scrcont = Scrcont + 1
   Waitms 50      
   Send$ = "{027}MN{003}"                                   'starts macro#3 (out1&out2=low)
   Gosub Dspl
   Waitms 500
   Send$ = "{027}MN{002}"                                   'starts macro#2 (clear screen)
   Gosub Dspl
   Waitms 500
 End If
Return



Yesnoscreen:
 If Scrcont <> Prvscrcont Then
   Send$ = "#ZF1"                                           'select font#1
   Gosub Dspl
   Send$ = "{027}ZZ{002}{002}"                              'zoom font
   Gosub Dspl
   Send$ = "{027}ZC{101}{030}WOULD YOU LIKE TO DRINK"
   Gosub Dspl
   Send$ = "{027}ZC{101}{050}A GLASS OF SPARKLING"
   Gosub Dspl
   Send$ = "{027}ZC{101}{070}WINE FOR FREE?"
   Gosub Dspl
   Send$ = "{027}MN{005}"                                   'starts macro#5 (yes & no button)
   Gosub Dspl
 End If
 Prvscrcont = Scrcont
 If Pinb.0 = 1 Or Pinb.1 = 1 Then
   Scrcont = Scrcont + 1
   Waitms 50
   Send$ = "{027}MN{003}"                                   'starts macro#3 (out1&out2=low)
   Gosub Dspl
   Waitms 500
   Send$ = "{027}MN{002}"                                   'starts macro#2 (clear screen)
   Gosub Dspl
   Waitms 500
 End If
return



Abscreen:
 If Scrcont <> Prvscrcont Then
   Send$ = "#ZF1"                                           'select font#1
   Gosub Dspl
   Send$ = "{027}ZZ{001}{001}"                              'zoom font
   Gosub Dspl
   Send$ = "{027}ZL{005}{023}Bitte erg{132}nzen Sie folgenden L{129}ckentext:"
   Gosub Dspl
   Send$ = "#ZF4"
   Gosub Dspl
   Send$ = "{027}ZC{101}{038}Wer A sagt, muss|auch ... sagen!"
   Gosub Dspl
   Send$ = "{027}MN{007}"                                   'starts macro#7 (A & B button)
   Gosub Dspl
 End If
 Prvscrcont = Scrcont
 If Pinb.0 = 1 Or Pinb.1 = 1 Then
   Scrcont = Scrcont + 1
   Waitms 50
   Send$ = "{027}MN{003}"                                   'starts macro#3 (out1&out2=low)
   Gosub Dspl
   Waitms 500
   Send$ = "{027}MN{002}"                                   'starts macro#2 (clear screen)
   Gosub Dspl
   Waitms 500
 End If
return



Leftrightscreen:
 If Scrcont <> Prvscrcont Then
   Send$ = "#ZF0"
   Gosub Dspl
   Send$ = "{027}ZZ{004}{001}"
   Gosub Dspl
   Send$ = "{027}ZL{010}{040}WHERE|DO YOU|WANT|TO GO|TODAY?"
   Gosub Dspl
   Send$ = "{027}QI{102}{018}{203}{078}"
   Gosub Dspl
   Send$ = "{027}MN{006}"                                   'starts macro#6 (left & right button)
   Gosub Dspl
 End If
 Prvscrcont = Scrcont
 If Pinb.0 = 1 Or Pinb.1 = 1 Then
   Scrcont = 0
   Waitms 50
   Send$ = "{027}MN{003}"                                   'starts macro#3 (out1&out2=low)
   Gosub Dspl
   Waitms 500
   Send$ = "{027}MN{002}"                                   'starts macro#2 (clear screen)
   Gosub Dspl
   Waitms 500
 End If
return


End

'---------------------------------------------------------------------------------
'----------------  Subroutine for sending data to edip 240-7 ---------------------
'---------------------------------------------------------------------------------
Dspl:
    Send$ = Send$ + Chr(13) + Chr(10)
    Sendlength = Len(send$)
    I2csend &B11011111 , Send(1) , Sendlength
Return
'---------------------------------------------------------------------------------
'--------- Subroutine for reading out the volume bargraph at edip 240-7 ----------
'---------------------------------------------------------------------------------
Readvol:
   Receivevol(1) = 27
   Receivevol(2) = 66
   Receivevol(3) = 83
   Receivevol(4) = 1
   I2csend &B11011111 , Receivevol(1) , 4
   I2creceive &B11011110 , Receivevol(1) , 0 , 5
   Volume = Receivevol(5)
Return